"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.mts
var src_exports = {};
__export(src_exports, {
  console: () => console,
  consoleErrorLine: () => consoleErrorLine
});
module.exports = __toCommonJS(src_exports);
var import_state2 = require("@codemirror/state");
var import_view3 = require("@codemirror/view");
var import_codemirror = require("codemirror");

// src/stickToBottom.mts
var import_view = require("@codemirror/view");
var PIXEL_BUFFER = 100;
var StickToBottomViewPlugin = class {
  constructor(view) {
    this._animationFrameRequest = null;
    this._stickToBottom = false;
  }
  update(update) {
    if (this._animationFrameRequest != null || !update.viewportChanged) {
      return;
    }
    if (!this._stickToBottom) {
      this._stickToBottom = Math.abs(
        update.view.scrollDOM.scrollHeight - Math.round(update.view.scrollDOM.scrollTop) - update.view.scrollDOM.clientHeight
      ) < PIXEL_BUFFER;
      if (!this._stickToBottom) {
        return;
      }
    }
    const onScroll = () => {
      if (this._animationFrameRequest == null) {
        return;
      }
      cancelAnimationFrame(this._animationFrameRequest);
      this._animationFrameRequest = null;
      this._stickToBottom = false;
    };
    this._animationFrameRequest = requestAnimationFrame(() => {
      update.view.scrollDOM.removeEventListener("scroll", onScroll);
      update.view.scrollDOM.scroll({
        top: update.view.scrollDOM.scrollHeight,
        behavior: "instant"
      });
      this._animationFrameRequest = null;
      this._stickToBottom = true;
    });
    update.view.scrollDOM.addEventListener("scroll", onScroll);
  }
};
function getStickToBottomViewPlugin() {
  const plugin = import_view.ViewPlugin.fromClass(StickToBottomViewPlugin);
  return plugin;
}

// src/addConsoleError.mts
var import_state = require("@codemirror/state");
var import_view2 = require("@codemirror/view");
var addConsoleError = import_state.StateEffect.define({
  map: ({ from, to }, change) => {
    return {
      from: change.mapPos(from),
      to: change.mapPos(to)
    };
  }
});
var consoleErrorField = import_state.StateField.define({
  create() {
    return import_view2.Decoration.none;
  },
  update(errors, tr) {
    errors = errors.map(tr.changes);
    for (const effect of tr.effects)
      if (effect.is(addConsoleError)) {
        errors = errors.update({
          add: [consoleErrorMark.range(effect.value.from, effect.value.to)]
        });
      }
    return errors;
  },
  provide: (field) => import_view2.EditorView.decorations.from(field)
});
var consoleErrorMark = import_view2.Decoration.mark({ class: "cm-console-error" });
var consoleErrorTheme = import_view2.EditorView.baseTheme({
  ".cm-console-error": { color: "red" }
});
function consoleErrorLine(view, lineNumber) {
  const line = view.state.doc.line(lineNumber);
  const effects = [
    addConsoleError.of({ from: line.from, to: line.to })
  ];
  if (view.state.field(consoleErrorField, false) == null) {
    effects.push(
      import_state.StateEffect.appendConfig.of([consoleErrorField, consoleErrorTheme])
    );
  }
  view.dispatch({ effects });
  return true;
}

// src/index.mts
function console() {
  const stickToBottom = getStickToBottomViewPlugin();
  return [
    import_codemirror.minimalSetup,
    import_state2.EditorState.readOnly.of(true),
    stickToBottom,
    import_view3.EditorView.lineWrapping
  ];
}
//# sourceMappingURL=index.cjs.map
